------------------------
----Arena Calculator----
----    by Toppe    ----
------------------------



local ACalc_RoundOff=0;


function ACalc_ChatCommand(cmd)
   argv = {};
   for arg in string.gmatch(string.lower(cmd), '[%a%d%-%.]+') do table.insert(argv, arg) end
   if (argv[1]==nil) then
      DEFAULT_CHAT_FRAME:AddMessage("|cAAFFD100Arena Calculator v1.4|r command list")
      DEFAULT_CHAT_FRAME:AddMessage(" show |cAACCFF99- show the Arena Calculator frame|r")
      DEFAULT_CHAT_FRAME:AddMessage(" scale # |cAACCFF99- set the scale of the Arena Calculator frame (0.3 - 2.0) |r")
      DEFAULT_CHAT_FRAME:AddMessage(" teams |cAACCFF99- print arena teams information in the chat|r")
      DEFAULT_CHAT_FRAME:AddMessage(" rating # |cAACCFF99- calculate rating-to-points in the chat|r")
      DEFAULT_CHAT_FRAME:AddMessage(" points # |cAACCFF99- calculate points-to-rating in the chat|r")
   elseif (argv[1]=="show") then
      ACalc_ShowHide();
   elseif (argv[1]=="teams") then
      ACalc_ChatPrint();
   elseif (argv[1]=="scale") then
      local newarg=tonumber(argv[2]);
      if (newarg>=0.3 and newarg<=2.0) then
         ACalcFrame:SetScale(newarg);
         ACalcFrame:ClearAllPoints();
         ACalcFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 0);
         ACalc_SavedOpt.ACalcFrameScale=newarg;
         ACalcFrameOptionsSlider1:SetValue(newarg);
      else
         DEFAULT_CHAT_FRAME:AddMessage("|cAACCFF99Scale must be between 0.3 and 2.0|r");
      end
   elseif (argv[1]=="rating") then
      local newarg=tonumber(argv[2]);
      ACalc_FrameCalc1(2, newarg);
   elseif (argv[1]=="points") then
      local newarg=tonumber(argv[2]);
      if type(newarg)=="number" then
         ACalc_FrameCalc2(2, newarg);
      else
         DEFAULT_CHAT_FRAME:AddMessage("|cAACCFF99Value must be a number.|r");
      end
   end
end


SlashCmdList["ACALC"] = ACalc_ChatCommand;
SLASH_ACALC1 = "/acalc";
SLASH_ACALC2 = "/arenacalc";
SLASH_ACALC3 = "/arenacalculator";



BINDING_HEADER_ACALC = "Arena Calculator Bindings";
BINDING_NAME_TOGGLEACALC = "Toggle ACalc Window";



function ACalc_ShowHide()
   if ACalcFrame:IsShown() then
      if ACalcFrameOptions:IsShown() then
         ACalcFrameOptions:Hide();
      end
      ACalcFrame:Hide();
   else
      UIFrameFadeIn(ACalcFrame, 0.2, 0, 1);
      ACalcFrame:Show();
   end
end

function ACalcOpt_ShowHide()
   if ACalcFrameOptions:IsShown() then
      ACalcFrameOptions:Hide();
   else
      ACalcFrameOptions:Show();
   end
end

function ACalcOpt_Default()
   ACalc_SavedOpt.ShowTotal=1;
   ACalcFrameOptionsCheckButton1:SetChecked(true);

   ACalc_SavedOpt.ShowTeams=1;
   ACalcFrameOptionsCheckButton2:SetChecked(true);
   
   ACalc_SavedOpt.Recolor=0;
   ACalcFrameOptionsCheckButton4:SetChecked(false);

   ACalc_Main();

   ACalc_SavedOpt.ShowButton=1;
   ACalcFrameOptionsCheckButton3:SetChecked(true);
   ACalc_ShowFrame:Show();

   ACalc_SavedOpt.ACalcFrameScale=1.0;
   ACalcFrameOptionsSlider1:SetValue(1.0);
   ACalcFrame:SetScale(1.0);
   ACalcFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 0);
end


-------------------------------------------
------- RATING TO POINTS CALCULATOR -------
-------------------------------------------


function ACalc_FrameCalc1(n, arg)
   local ACalc_CalcNumber1=0;
   if n==1 then
      ACalc_CalcNumber1=ACalcFrameBox1EditBox:GetNumber();
   elseif n==2 then
      ACalc_CalcNumber1=arg;
   end
   local ACalc_FrameCalcAnswer1=0;
   local ACalc_FrameCalcAnswer2=0;
   local ACalc_FrameCalcAnswer3=0;

   if ACalc_CalcNumber1>1500 then
      ACalc_FrameCalcAnswer1=(1426.79/(1 + 918.836 * math.exp(-0.00386405*ACalc_CalcNumber1)));
      ACalc_FrameCalcAnswer2=0.8*ACalc_FrameCalcAnswer1;
      ACalc_FrameCalcAnswer3=0.7*ACalc_FrameCalcAnswer1;
   elseif ACalc_CalcNumber1<1501 then
      ACalc_FrameCalcAnswer1=0.38*ACalc_CalcNumber1-194;
      ACalc_FrameCalcAnswer2=0.8*ACalc_FrameCalcAnswer1;
      ACalc_FrameCalcAnswer3=0.7*ACalc_FrameCalcAnswer1;
   end

   if ACalc_FrameCalcAnswer1<0 then
      ACalc_FrameCalcAnswer1=0;
   end
   if ACalc_FrameCalcAnswer2<0 then
      ACalc_FrameCalcAnswer2=0;
   end
   if ACalc_FrameCalcAnswer3<0 then
      ACalc_FrameCalcAnswer3=0;
   end

   if n==1 then
      ACalcFrameTextAnswer1:SetText("|cAAFFD1002v2:|r "..math.floor(ACalc_FrameCalcAnswer3+ACalc_RoundOff).."|n".."|cAAFFD1003v3:|r "..math.floor(ACalc_FrameCalcAnswer2+ACalc_RoundOff).."|n".."|cAAFFD1005v5:|r "..math.floor(ACalc_FrameCalcAnswer1+ACalc_RoundOff));
   elseif n==2 then
      DEFAULT_CHAT_FRAME:AddMessage("|cAAFFD1002v2:|r  |cAACCFF99Points:|r "..math.floor(ACalc_FrameCalcAnswer3+ACalc_RoundOff).."|cAACCFF99.|r");
      DEFAULT_CHAT_FRAME:AddMessage("|cAAFFD1003v3:|r  |cAACCFF99Points:|r "..math.floor(ACalc_FrameCalcAnswer2+ACalc_RoundOff).."|cAACCFF99.|r");
      DEFAULT_CHAT_FRAME:AddMessage("|cAAFFD1005v5:|r  |cAACCFF99Points:|r "..math.floor(ACalc_FrameCalcAnswer1+ACalc_RoundOff).."|cAACCFF99.|r");
   end
end



-------------------------------------------
------- POINTS TO RATING CALCULATOR -------
-------------------------------------------


function ACalc_FrameCalc2(n, arg)
   local ACalc_CalcNumber2=0;
   if n==1 then
      ACalc_CalcNumber2=ACalcFrameBox2EditBox2:GetNumber();
   elseif n==2 then
      ACalc_CalcNumber2=arg;
   end
   local ACalc_Answer1=ACalc_CalcNumber2/0.7;
   local ACalc_Answer2=ACalc_CalcNumber2/0.8;
   local ACalc_Answer3=ACalc_CalcNumber2;

   if ACalc_Answer1>263 and ACalc_Answer1<1427 then
      ACalc_Answer1=math.floor((math.log((1426.79/ACalc_Answer1 - 1) / 918.836) / -.00386405)+.5);
   elseif ACalc_Answer1<264 then
      ACalc_Answer1=math.floor(((ACalc_Answer1 + 194) / .38)+.5);
   else
      ACalc_Answer1="N/A";
   end

   if ACalc_Answer2>301 and ACalc_Answer2<1427 then
      ACalc_Answer2=math.floor((math.log((1426.79/ACalc_Answer2 - 1) / 918.836) / -.00386405)+.5);
   elseif ACalc_Answer2<302 then
      ACalc_Answer2=math.floor(((ACalc_Answer2 + 194) / .38)+.5);
   else
      ACalc_Answer2="N/A";
   end

   if ACalc_Answer3>376 and ACalc_Answer3<1427 then
      ACalc_Answer3=math.floor((math.log((1426.79/ACalc_Answer3 - 1) / 918.836) / -.00386405)+.5);
   elseif ACalc_Answer3<377 then
      ACalc_Answer3=math.floor(((ACalc_Answer3 + 194) / .38)+.5);
   else
      ACalc_Answer3="N/A";
   end
   
   if n==1 then
      ACalcFrameTextAnswer2:SetText("|cAAFFD1002v2:|r "..ACalc_Answer1.."|n".."|cAAFFD1003v3:|r "..ACalc_Answer2.."|n".."|cAAFFD1005v5:|r "..ACalc_Answer3);
   elseif n==2 then
      DEFAULT_CHAT_FRAME:AddMessage("|cAAFFD1002v2:|r  |cAACCFF99Rating:|r "..ACalc_Answer1.."|cAACCFF99.|r");
      DEFAULT_CHAT_FRAME:AddMessage("|cAAFFD1003v3:|r  |cAACCFF99Rating:|r "..ACalc_Answer2.."|cAACCFF99.|r");
      DEFAULT_CHAT_FRAME:AddMessage("|cAAFFD1005v5:|r  |cAACCFF99Rating:|r "..ACalc_Answer3.."|cAACCFF99.|r");
   end
end



------------------------------------
-------- START CHAT FUNCTION -------
------------------------------------


function ACalc_ChatPrint()

   local ACalc_ArenaTeam1Points, ACalc_ArenaTeam2Points, ACalc_ArenaTeam3Points, ACalc_ArenaTeam1Rating, ACalc_ArenaTeam2Rating, ACalc_ArenaTeam3Rating, ACalc_max, ACalc_maxrecolor, ACalc_TeamRecolor = unpack(ACalc_MainCalc());


   ACalc_max=ACalc_max+GetArenaCurrency();

   if ACalc_ArenaTeam1Points>0 then
      DEFAULT_CHAT_FRAME:AddMessage("|cAAFFD1002v2:|r  |cAACCFF99Rating:|r "..ACalc_ArenaTeam1Rating.."|cAACCFF99. Points:|r "..ACalc_ArenaTeam1Points.."|cAACCFF99.|r");
   end
   if ACalc_ArenaTeam2Points>0 then
      DEFAULT_CHAT_FRAME:AddMessage("|cAAFFD1003v3:|r  |cAACCFF99Rating:|r "..ACalc_ArenaTeam2Rating.."|cAACCFF99. Points:|r "..ACalc_ArenaTeam2Points.."|cAACCFF99.|r");
   end
   if ACalc_ArenaTeam3Points>0 then
      DEFAULT_CHAT_FRAME:AddMessage("|cAAFFD1005v5:|r  |cAACCFF99Rating:|r "..ACalc_ArenaTeam3Rating.."|cAACCFF99. Points:|r "..ACalc_ArenaTeam3Points.."|cAACCFF99.|r");
   end
   if ACalc_max>GetArenaCurrency() then
      if ACalc_maxrecolor==1 then
         DEFAULT_CHAT_FRAME:AddMessage("|cAACCFF99Current points:|r "..GetArenaCurrency().."|cAACCFF99. Total points:|r |cAACC0000"..ACalc_max.."|r|cAACCFF99.|r |cAACC0000(Not eligible)|r");
      else
         DEFAULT_CHAT_FRAME:AddMessage("|cAACCFF99Current points:|r "..GetArenaCurrency().."|cAACCFF99. Total points:|r "..ACalc_max.."|cAACCFF99.|r");
      end
   else
      DEFAULT_CHAT_FRAME:AddMessage("|cAACCFF99You don't have any arena teams.|r");
   end
end



-----------------------------------------
-------- START MAIN CALC FUNCTION -------
-----------------------------------------

function ACalc_MainCalc()

   local ACalc_ArenaTeam1Points=0;
   local ACalc_ArenaTeam2Points=0;
   local ACalc_ArenaTeam3Points=0;
   
   local ACalc_ArenaTeam1Played=0;
   local ACalc_ArenaTeam2Played=0;
   local ACalc_ArenaTeam3Played=0;

   local ACalc_ArenaTeam1playerPlayed=0;
   local ACalc_ArenaTeam2playerPlayed=0;
   local ACalc_ArenaTeam3playerPlayed=0;

   -- Get all teamratings.
   local ACalc_ArenaTeam1Rating=ACalc_Rating(1);
   local ACalc_ArenaTeam2Rating=ACalc_Rating(2);
   local ACalc_ArenaTeam3Rating=ACalc_Rating(3);


   -- Learn which team is in what bracket, calculate their points, and get teamplayed and playerplayed data.
   if ACalc_Size(1)==2 then
      ACalc_ArenaTeam1Points=math.floor(ACalc_Calculate(1)+ACalc_RoundOff)
      ACalc_ArenaTeam1Rating=ACalc_Rating(1);
      ACalc_ArenaTeam1Played=ACalc_Played(1);
      ACalc_ArenaTeam1playerPlayed=ACalc_playerPlayed(1);
   elseif ACalc_Size(1)==3 then
      ACalc_ArenaTeam2Points=math.floor(ACalc_Calculate(1)+ACalc_RoundOff);
      ACalc_ArenaTeam2Rating=ACalc_Rating(1);
      ACalc_ArenaTeam2Played=ACalc_Played(1);
      ACalc_ArenaTeam2playerPlayed=ACalc_playerPlayed(1);
   elseif ACalc_Size(1)==5 then
      ACalc_ArenaTeam3Points=math.floor(ACalc_Calculate(1)+ACalc_RoundOff);
      ACalc_ArenaTeam3Rating=ACalc_Rating(1);
      ACalc_ArenaTeam3Played=ACalc_Played(1);
      ACalc_ArenaTeam3playerPlayed=ACalc_playerPlayed(1);
   end

   if ACalc_Size(2)==2 then
      ACalc_ArenaTeam1Points=math.floor(ACalc_Calculate(2)+ACalc_RoundOff);
      ACalc_ArenaTeam1Rating=ACalc_Rating(2);
      ACalc_ArenaTeam1Played=ACalc_Played(2);
      ACalc_ArenaTeam1playerPlayed=ACalc_playerPlayed(2);
   elseif ACalc_Size(2)==3 then
      ACalc_ArenaTeam2Points=math.floor(ACalc_Calculate(2)+ACalc_RoundOff);
      ACalc_ArenaTeam2Rating=ACalc_Rating(2);
      ACalc_ArenaTeam2Played=ACalc_Played(2);
      ACalc_ArenaTeam2playerPlayed=ACalc_playerPlayed(2);
   elseif ACalc_Size(2)==5 then
      ACalc_ArenaTeam3Points=math.floor(ACalc_Calculate(2)+ACalc_RoundOff);
      ACalc_ArenaTeam3Rating=ACalc_Rating(2);
      ACalc_ArenaTeam3Played=ACalc_Played(2);
      ACalc_ArenaTeam3playerPlayed=ACalc_playerPlayed(2);
   end

   if ACalc_Size(3)==2 then
      ACalc_ArenaTeam1Points=math.floor(ACalc_Calculate(3)+ACalc_RoundOff);
      ACalc_ArenaTeam1Rating=ACalc_Rating(3);
      ACalc_ArenaTeam1Played=ACalc_Played(3);
      ACalc_ArenaTeam1playerPlayed=ACalc_playerPlayed(3);
   elseif ACalc_Size(3)==3 then
      ACalc_ArenaTeam2Points=math.floor(ACalc_Calculate(3)+ACalc_RoundOff);
      ACalc_ArenaTeam2Rating=ACalc_Rating(3);
      ACalc_ArenaTeam2Played=ACalc_Played(3);
      ACalc_ArenaTeam2playerPlayed=ACalc_playerPlayed(3);
   elseif ACalc_Size(3)==5 then
      ACalc_ArenaTeam3Points=math.floor(ACalc_Calculate(3)+ACalc_RoundOff);
      ACalc_ArenaTeam3Rating=ACalc_Rating(3);
      ACalc_ArenaTeam3Played=ACalc_Played(3);
      ACalc_ArenaTeam3playerPlayed=ACalc_playerPlayed(3);
   end
   

   -- Get percent of player played against team played, if team has played more than 10 matches.
   local ACalc_ArenaTeam1playerPlayedPct=0;
   if ACalc_ArenaTeam1Played>=10 then
      ACalc_ArenaTeam1playerPlayedPct=floor((ACalc_ArenaTeam1playerPlayed/ACalc_ArenaTeam1Played)*100);
   else
      ACalc_ArenaTeam1playerPlayedPct=0;
   end
   
   local ACalc_ArenaTeam2playerPlayedPct=0;
   if ACalc_ArenaTeam2Played>=10 then
      ACalc_ArenaTeam2playerPlayedPct=floor((ACalc_ArenaTeam2playerPlayed/ACalc_ArenaTeam2Played)*100);
   else
      ACalc_ArenaTeam2playerPlayedPct=0;
   end

   local ACalc_ArenaTeam3playerPlayedPct=0;
   if ACalc_ArenaTeam3Played>=10 then
      ACalc_ArenaTeam3playerPlayedPct=floor((ACalc_ArenaTeam3playerPlayed/ACalc_ArenaTeam3Played)*100);
   else
      ACalc_ArenaTeam3playerPlayedPct=0;
   end



   local ACalc_LeadingTeam=0;
   local ACalc_SecondTeam=0;
   local ACalc_ThirdTeam=0;
   local ACalc_TeamRecolor=0;

   -- Create a table (array) with all teams points and sort it most->least
   local ACalc_TeamsTable={ACalc_ArenaTeam1Points, ACalc_ArenaTeam2Points, ACalc_ArenaTeam3Points};
   table.sort(ACalc_TeamsTable, function(a,b) return a>b end);

   -- See which team is actually leading (and second / third) by checking most amount of points to all teams points, and so on.
   if ACalc_TeamsTable[1]==ACalc_ArenaTeam1Points then
      ACalc_LeadingTeam=1;
   elseif ACalc_TeamsTable[1]==ACalc_ArenaTeam2Points then
      ACalc_LeadingTeam=2;
   elseif ACalc_TeamsTable[1]==ACalc_ArenaTeam3Points then
      ACalc_LeadingTeam=3;
   end
   if ACalc_TeamsTable[2]==ACalc_ArenaTeam1Points then
      ACalc_SecondTeam=1;
   elseif ACalc_TeamsTable[2]==ACalc_ArenaTeam2Points then
      ACalc_SecondTeam=2;
   elseif ACalc_TeamsTable[2]==ACalc_ArenaTeam3Points then
      ACalc_SecondTeam=3;
   end
   if ACalc_TeamsTable[3]==ACalc_ArenaTeam1Points then
      ACalc_ThirdTeam=1;
   elseif ACalc_TeamsTable[3]==ACalc_ArenaTeam2Points then
      ACalc_ThirdTeam=2;
   elseif ACalc_TeamsTable[3]==ACalc_ArenaTeam3Points then
      ACalc_ThirdTeam=3;
   end

   -- Check which team is to be recolored.
   if ACalc_LeadingTeam==1 and ACalc_ArenaTeam1playerPlayedPct>=30 then
      ACalc_TeamRecolor=1
   elseif ACalc_LeadingTeam==2 and ACalc_ArenaTeam2playerPlayedPct>=30 then
      ACalc_TeamRecolor=2
   elseif ACalc_LeadingTeam==3 and ACalc_ArenaTeam3playerPlayedPct>=30 then
      ACalc_TeamRecolor=3
   elseif ACalc_SecondTeam==1 and ACalc_ArenaTeam1playerPlayedPct>=30 then
      ACalc_TeamRecolor=1
   elseif ACalc_SecondTeam==2 and ACalc_ArenaTeam2playerPlayedPct>=30 then
      ACalc_TeamRecolor=2
   elseif ACalc_SecondTeam==3 and ACalc_ArenaTeam3playerPlayedPct>=30 then
      ACalc_TeamRecolor=3
   elseif ACalc_ThirdTeam==1 and ACalc_ArenaTeam1playerPlayedPct>=30 then
      ACalc_TeamRecolor=1
   elseif ACalc_ThirdTeam==2 and ACalc_ArenaTeam2playerPlayedPct>=30 then
      ACalc_TeamRecolor=2
   elseif ACalc_ThirdTeam==3 and ACalc_ArenaTeam3playerPlayedPct>=30 then
      ACalc_TeamRecolor=3
   end
   
   
   -- Get max points, and see if there is a need to recolor total arena points.
   local ACalc_max=0;
   local ACalc_maxrecolor=0;
   if ACalc_TeamRecolor==1 then
      ACalc_max=ACalc_ArenaTeam1Points;
   elseif ACalc_TeamRecolor==2 then
      ACalc_max=ACalc_ArenaTeam2Points;
   elseif ACalc_TeamRecolor==3 then
      ACalc_max=ACalc_ArenaTeam3Points;
   else
      ACalc_max=math.max(ACalc_ArenaTeam1Points, ACalc_ArenaTeam2Points, ACalc_ArenaTeam3Points);
      ACalc_maxrecolor=1;
   end
   local ACalc_MainCalcArray={ACalc_ArenaTeam1Points, ACalc_ArenaTeam2Points, ACalc_ArenaTeam3Points, ACalc_ArenaTeam1Rating, ACalc_ArenaTeam2Rating, ACalc_ArenaTeam3Rating, ACalc_max, ACalc_maxrecolor, ACalc_TeamRecolor}
   return ACalc_MainCalcArray;
end



------------------------------------
-------- START MAIN FUNCTION -------
------------------------------------


function ACalc_Main()

   local ACalc_ArenaTeam1Points, ACalc_ArenaTeam2Points, ACalc_ArenaTeam3Points, ACalc_ArenaTeam1Rating, ACalc_ArenaTeam2Rating, ACalc_ArenaTeam3Rating, ACalc_max, ACalc_maxrecolor, ACalc_TeamRecolor = unpack(ACalc_MainCalc());


   -- If option to show teams points in PVP frame is on, show them. Recolor if setting to do so is on.
   if ACalc_SavedOpt.ShowTeams==1 then
      PVPTeam1DataRatingLabel:ClearAllPoints();
      PVPTeam1DataRatingLabel:SetPoint("RIGHT",PVPTeam1DataName,"RIGHT",5,0);
      if ACalc_ArenaTeam1Points>0 then
         PVPTeam1DataRating:SetText(ACalc_ArenaTeam1Rating.." ("..ACalc_ArenaTeam1Points..")");
      end
      if ACalc_SavedOpt.Recolor==1 then
         if ACalc_TeamRecolor==1 then
            PVPTeam1DataRating:SetText(ACalc_ArenaTeam1Rating.." |cAA99FF00("..ACalc_ArenaTeam1Points..")|r");
         end
      end
      PVPTeam1DataRating:SetJustifyH("CENTER");
      PVPTeam1DataRating:SetWidth(70);
	
      PVPTeam2DataRatingLabel:ClearAllPoints();
      PVPTeam2DataRatingLabel:SetPoint("RIGHT",PVPTeam2DataName,"RIGHT",5,0);
      if ACalc_ArenaTeam2Points>0 then
         PVPTeam2DataRating:SetText(ACalc_ArenaTeam2Rating.." ("..ACalc_ArenaTeam2Points..")");
      end
      if ACalc_SavedOpt.Recolor==1 then
         if ACalc_TeamRecolor==2 then
            PVPTeam1DataRating:SetText(ACalc_ArenaTeam2Rating.." |cAA99FF00("..ACalc_ArenaTeam2Points..")|r");
         end
      end
      PVPTeam2DataRating:SetJustifyH("CENTER");
      PVPTeam2DataRating:SetWidth(70);
	
      PVPTeam3DataRatingLabel:ClearAllPoints();
      PVPTeam3DataRatingLabel:SetPoint("RIGHT",PVPTeam3DataName,"RIGHT",5,0);
      if ACalc_ArenaTeam3Points>0 then
         PVPTeam3DataRating:SetText(ACalc_ArenaTeam3Rating.." ("..ACalc_ArenaTeam3Points..")");
      end
      if ACalc_SavedOpt.Recolor==1 then
         if ACalc_TeamRecolor==3 then
            PVPTeam1DataRating:SetText(ACalc_ArenaTeam3Rating.." |cAA99FF00("..ACalc_ArenaTeam3Points..")|r");
         end
      end
      PVPTeam3DataRating:SetJustifyH("CENTER");
      PVPTeam3DataRating:SetWidth(70);
   else
      PVPTeam1DataRatingLabel:ClearAllPoints();
      PVPTeam1DataRatingLabel:SetPoint("LEFT", PVPTeam1DataName, "RIGHT", 0, 0);
      if ACalc_ArenaTeam1Points>0 then
         PVPTeam1DataRating:SetText(ACalc_ArenaTeam1Rating);
      end
      PVPTeam1DataRating:SetJustifyH("LEFT");
      PVPTeam1DataRating:SetWidth(60);
	
      PVPTeam2DataRatingLabel:ClearAllPoints();
      PVPTeam2DataRatingLabel:SetPoint("LEFT", PVPTeam2DataName, "RIGHT", 0, 0);
      if ACalc_ArenaTeam2Points>0 then
         PVPTeam2DataRating:SetText(ACalc_ArenaTeam2Rating);
      end
      PVPTeam2DataRating:SetJustifyH("LEFT");
      PVPTeam2DataRating:SetWidth(60);
	
      PVPTeam3DataRatingLabel:ClearAllPoints();
      PVPTeam3DataRatingLabel:SetPoint("LEFT", PVPTeam3DataName, "RIGHT", 0, 0);
      if ACalc_ArenaTeam3Points>0 then
         PVPTeam3DataRating:SetText(ACalc_ArenaTeam3Rating);
      end
      PVPTeam3DataRating:SetJustifyH("LEFT");
      PVPTeam3DataRating:SetWidth(60);
   end




   -- Set up variable with current arena points and total arena points after next update. Also recolor if necessary.
   local ACalc_APWidth=85;
   ACalc_max=ACalc_max+GetArenaCurrency();
   if ACalc_SavedOpt.Recolor==1 and ACalc_maxrecolor==1 then
      ACalc_max=(GetArenaCurrency().." |cAACC3300("..ACalc_max..")|r");
      -- Find out needed width of current arena points frame. (String is longer here because of recoloring)
      if #ACalc_max<18 then
         ACalc_APWidth=40;
      elseif #ACalc_max<22 then
         ACalc_APWidth=65;
      elseif #ACalc_max<23 then
         ACalc_APWidth=75;
      elseif #ACalc_max<24 then
         ACalc_APWidth=85;
      end
   else
      ACalc_max=(GetArenaCurrency().." ("..ACalc_max..")");
      -- Find out needed width of current arena points frame.
      if #ACalc_max<6 then
         ACalc_APWidth=40;
      elseif #ACalc_max<10 then
         ACalc_APWidth=65;
      elseif #ACalc_max<11 then
         ACalc_APWidth=75;
      elseif #ACalc_max<12 then
         ACalc_APWidth=85;
      end
   end




   -- If option to show total arena points is on, show it.
   if ACalc_SavedOpt.ShowTotal==1 then
      PVPFrameArenaPoints:SetText(ACalc_max);
      PVPFrameArenaPoints:SetPoint("LEFT", PVPFrameArenaLabel, "RIGHT", 4, 0);
      PVPFrameArenaPoints:SetJustifyH("CENTER");
      PVPFrameArenaPoints:SetWidth(ACalc_APWidth);
   else
      PVPFrameArenaPoints:SetText(GetArenaCurrency());
      PVPFrameArenaPoints:SetPoint("LEFT", PVPFrameArenaLabel, "RIGHT", 15, 0);
      PVPFrameArenaPoints:SetJustifyH("RIGHT");
      if #PVPFrameArenaPoints<2 then
         PVPFrameArenaPoints:SetWidth(16);
      else
         PVPFrameArenaPoints:SetWidth(25);
      end
   end
end


--------------------------------------------------------
------- ONLOAD, ONEVENT, LOADVARIABLES AND HOOKS -------
--------------------------------------------------------



function ACalc_OnLoad()
   this:RegisterEvent("ADDON_LOADED");
end

function ACalc_OnEvent()
   if (event=="ADDON_LOADED" and arg1=="ArenaCalculator") then
      ACalc_LoadVariables();
   end
end

-- Load SavedVariables, or set them if there are no saved ones. Call FuncHooks() after.
function ACalc_LoadVariables()
   if not ACalc_SavedOpt then
      ACalc_SavedOpt={};
      ACalc_SavedOpt.ShowTotal=1
      ACalc_SavedOpt.ShowTeams=1
      ACalc_SavedOpt.ShowButton=1
      ACalc_SavedOpt.Recolor=0
      ACalc_SavedOpt.ACalcFrameScale=1.0
   end
   if ACalc_SavedOpt.ShowTotal==0 then
      ACalcFrameOptionsCheckButton1:SetChecked(false);
   end
   if ACalc_SavedOpt.ShowTeams==0 then
      ACalcFrameOptionsCheckButton2:SetChecked(false);
   end
   if ACalc_SavedOpt.ShowButton==0 then
      ACalcFrameOptionsCheckButton3:SetChecked(false);
      ACalc_ShowFrame:Hide();
   else
      ACalcFrameOptionsCheckButton3:SetChecked(true);
      ACalc_ShowFrame:Show();
   end
   ACalcFrameOptionsSlider1:SetValue(ACalc_SavedOpt.ACalcFrameScale);
   ACalc_FuncHooks();
end

-- Hook the functions that updates arena related info, therefore updating ACalc also.
function ACalc_FuncHooks()
   local oldPVPFrame_Update=PVPFrame_Update
   function newPVPFrame_Update()
      oldPVPFrame_Update()
      ACalc_Main()
   end
   PVPFrame_Update=newPVPFrame_Update

   local oldPVPFrameToggleButton_OnClick=PVPFrameToggleButton_OnClick
   function newPVPFrameToggleButton_OnClick() 
      oldPVPFrameToggleButton_OnClick()
      ACalc_Main()
   end
   PVPFrameToggleButton_OnClick=newPVPFrameToggleButton_OnClick
end



------------------------------------
------- CHECKBUTTONS ONCLICK -------
------------------------------------


function ACalcFrameOptionsCheckButton1_OnClick()
   if ACalcFrameOptionsCheckButton1:GetChecked() then
      ACalc_SavedOpt.ShowTotal=1;
      ACalc_Main();
   else
      ACalc_SavedOpt.ShowTotal=0;
      ACalc_Main();
   end
end


function ACalcFrameOptionsCheckButton2_OnClick()
   if ACalcFrameOptionsCheckButton2:GetChecked() then
      ACalc_SavedOpt.ShowTeams=1;
      ACalc_Main();
   else
      ACalc_SavedOpt.ShowTeams=0;
      ACalc_Main();
   end
end


function ACalcFrameOptionsCheckButton3_OnClick()
   if ACalcFrameOptionsCheckButton3:GetChecked() then
      ACalc_SavedOpt.ShowButton=1;
      ACalc_ShowFrame:Show();
   else
      ACalc_SavedOpt.ShowButton=0;
      ACalc_ShowFrame:Hide();
      DEFAULT_CHAT_FRAME:AddMessage("|cAACCFF99You have disabled the Arena Calculator button. If you wish to open the Arena Calculator frame again, use |r/acalc show");
   end
end


function ACalcFrameOptionsCheckButton4_OnClick()
   if ACalcFrameOptionsCheckButton4:GetChecked() then
      ACalc_SavedOpt.Recolor=1;
      ACalc_Main();
   else
      ACalc_SavedOpt.Recolor=0;
      ACalc_Main();
   end
end


function ACalcFrameOptionsSlider1_OnClick()
      ACalc_SavedOpt.ACalcFrameScale=ACalcFrameOptionsSlider1:GetValue();
      ACalcFrame:SetScale(ACalcFrameOptionsSlider1:GetValue());
      ACalcFrame:SetPoint("CENTER", UIParent, "CENTER", 0, 0);
end



----------------------------------------
------- ARENA POINTS CALCULATION -------
----------------------------------------

function ACalc_Calculate(n)
   local points=0;
   local teamName, teamSize, teamRating, teamPlayed, teamWins, playerPlayed, teamRank  = GetArenaTeam(n);
   if teamRating>1500 then 
      points=(1426.79/(1+918.836*math.exp(-0.00386405*teamRating)));
      if teamSize==2 then
         points=0.7*points;
      elseif teamSize==3 then
         points=0.8*points;
      end
   elseif teamRating<1501 then
      points=0.38*teamRating-194;
      if points<0 then 
         points=0;
      end
      if teamSize==2 then
         points=0.7*points;
      elseif teamSize==3 then
         points=0.8*points;
      end
   end
   return points;
end



---------------------------------------------
------- GET RATINGS, SIZES AND PLAYED -------
---------------------------------------------

function ACalc_Rating(n)
	local teamName, teamSize, teamRating, teamPlayed, teamWins, playerPlayed, teamRank  = GetArenaTeam(n);
	return teamRating;
end


function ACalc_Size(n)
	local teamName, teamSize, teamRating, teamPlayed, teamWins, playerPlayed, teamRank  = GetArenaTeam(n);
	return teamSize;
end


function ACalc_Played(n)
	local teamName, teamSize, teamRating, teamPlayed, teamWins, playerPlayed, teamRank  = GetArenaTeam(n);
	return teamPlayed;
end


function ACalc_playerPlayed(n)
	local teamName, teamSize, teamRating, teamPlayed, teamWins, playerPlayed, teamRank  = GetArenaTeam(n);
	return playerPlayed;
end